/**********************************************************
 
Organify2.jsx

DESCRIPTION

An aggregate of randomization scripts from wundes.com 
bundled together in one neat little swf package.
 (requires jpanel.swf to function)
>=--------------------------------------
embedded JS code (c) copyright: John Wundes ( john@wundes.com ) www.wundes.com
copyright full text here:  http://www.wundes.com/js4ai/copyright.txt
//////////////////////////////////////////////////////////////////


The swf container script was built on an example from Adobe.com
**********************************************************/

#target illustrator

// The following directive names the global javascript engine that the script is
// to be executed in. This is necessary when instantiating a floating Script UI
// palette.
#targetengine com.adobe.illustrator.demo.flashplayer

try {
	if(BridgeTalk.appName != "illustrator")  { 
		throw new Error("Cannot run FlashPanel sample, need to be running in context of Illustrator\n");
	}
	if (flashPanel != undefined) {
		throw new Error("FlashPanel is already running\n");
	}
	
	// get the folder containing the .swf files
	// var swfFolder = Folder.selectDialog("Select the folder containing the swf files (FlashPanel/swf):"); // Use for release
        
	// Which OS are we on?
	if( File.fs == "Windows" ){
		var buttonSWF = "C:/Program Files/Adobe/Adobe Illustrator CS3/Presets/Scripts/organify2.swf";
	} else if( File.fs == "Macintosh" ){
		// var buttonSWF = "/Users/nvkelso/Desktop/Downloads/FlashPanel/registration.swf";
		var buttonSWF = "/Applications/Adobe Illustrator CS3/Presets.localized/Scripts.localized/organify2.swf";
	} else {
		alert("either Unix or Outerspace!!!");
	}	
	
	//var swfFolder = new Folder("C:/Documents and Settings/sashby/Desktop/FlashPanel/swf"); // For debug under Illustrator (edit path to where sample is installed)
	//var swfFolder = Folder(Folder($.fileName).path + "/swf"); // Use for debug in ESTK.

	// if ( swfFolder != null )  {
	if ( buttonSWF != null )  {
	// Create a resource to describe the ScriptUI window.
		var res =
		"palette {																			\
			text:' Organify Panel v2',															\
			properties:{ closeOnKey:'OSCmnd+W', resizeable:false},	\
			fp: FlashPlayer {																\
				preferredSize: [275, 40],												\
				alignment: ['fill', 'fill']													\
			},																					\
		}";

		//swfFiles: Group {orientation: 'row',									\
				//label: StaticText {text: 'Flash files:'},							\
				//list: DropDownList { },													\
		//},																					\

		// Create new FlashPanel Window object
		var flashPanel = new Window (res);
		flashPanel.margins = [2,2,2,2];

		// Populate dropdown with list of swf files from the given folder
		// var allFiles = swfFolder.getFiles ("*.swf");
		// for (var i = 0; i < allFiles.length; i++) {
			// var item = flashPanel.swfFiles.list.add ('item', allFiles[i].name);
		// }
		//var item = flashPanel.swfFiles.list.add ('item', buttonSWF );

		// Call loadFlashFile() when onChange event occurs
		//flashPanel.swfFiles.list.onChange = loadFlashFile;
		// Set the initial selection to the first file in the drop-down list
		// flashPanel.swfFiles.list.selection = flashPanel.swfFiles.list.items[0];
		loadFlashFile( buttonSWF );
		flashPanel.onClose = function(){if (flashPanel.animatorFlashPanelW != undefined) flashPanel.animatorFlashPanelW.close(); flashPanel = undefined;}
		
		// ExtendScript functions called back from ActionScript
		flashPanel.fp.organify= organify;
		flashPanel.fp.sharpen= sharpen;
		flashPanel.fp.vary= vary;
		flashPanel.fp.zoom= zoom;
		
		// Display window
		flashPanel.show();

	} // end if(swfFolder != null)
}
catch (ex) {
	alert(ex);
}

/** Generic handler for errors returned by BridgeTalk
	@param Object btObj the object containing the error details
*/
function flashPanelBridgeTalkErrorHandler (btObj) {
	alert( btObj.body + " (" + btObj.headers ["Error-Code"] + ")" ); 
}

/** Loads the Flash file selected in the swfFiles list in the FlashPanel window.
*/
function loadFlashFile( fileName ) {
	//if (this.selection == null) {
		//return;
	//}

	//var swfFileName = this.selection.toString();
	var swfFileName = fileName;

	
	// Load the SWF file into the player.
//	var flashFile = new File(swfFolder.absoluteURI + "/" + swfFileName);
	var flashFile = new File( fileName );
	if (flashFile.exists) {
		try  {
			flashPanel.fp.loadMovie (flashFile);
		}
		catch (e) {
			alert ("Exception caught in loadFlashFile():" +  e);
		}
	}
	else {
		alert("SWF file is missing: " + flashFile);
	}
}



	
function organify( thingies,num ) {
	/////////////////////////////////////////////////////////////////
	//Randomizes all selected anchors by a selected number of points.
	//
	//  Enter small numbers to make objects look hand drawn.
	//  Enter larger numbers to make objects look organic.
	//  Enter even larger numbers to distort beyond recognition.
	//
	// V.2 now offers a choice for randomizing 'Anchors Only', 'Control Handles Only' or both.
	//  <a href='http://www.wundes.com/js4ai/images/organifyDetail.gif'>(click here to view sample image.)</a>
	//>=--------------------------------------
	// JS code (c) copyright: John Wundes ( john@wundes.com ) www.wundes.com
	//copyright full text here:  http://www.wundes.com/js4ai/copyright.txt
	////////////////////////////////////////////////////////////////// 
	try{
		var bt = new BridgeTalk();
		bt.target = "illustrator";
	
		//send code:
		bt.body = "{\n"+
"var docRef= app.activeDocument;\n"+
"if ( app.documents.length > 0)\n"+
"{	\n"+
"	var max = docRef.selection.length;\n"+
"	//alert('thingies="+thingies+"', 'num="+num+":');\n"+
"	//alert(max);\n"+
"	rvar = '"+num+"';\n"+
"	things = '"+thingies+"';\n"+
"	switch (things){\n"+
"		case 'anchors' :\n"+
"			uchoice='1';\n"+
"			break;\n"+
"		case 'handles' :\n"+
"			uchoice='2';\n"+
"			break;\n"+
"		case 'both' :\n"+
"			uchoice='3';\n"+
"			break;\n"+
"	}\n"+
"	}\n"+
"	sel = activeDocument.selection[0];\n"+
"	for(var cpi=0;cpi<max;cpi++){\n"+
"		currentObj = activeDocument.selection[cpi];\n"+
"	testObj(currentObj);\n"+
"	}\n"+
"}\n"+
"function tweakPath(obj){\n"+
"		try{	//activeDocument.Selection.SelectedPathPoints		 \n"+
"			var adsspp = obj.selectedPathPoints;\n"+
"			var adssppLen = adsspp.length;\n"+
"			for (var x = 0;x<adssppLen;x++){\n"+
"			var spp = obj.selectedPathPoints[x];\n"+
"			if(uchoice!=2){\n"+
"			//Randomizes Anchors\n"+
"				va = spp.anchor[0]+((Math.random()*rvar)-(rvar/2));\n"+
"				vb = spp.anchor[1]+((Math.random()*rvar)-(rvar/2))\n"+
"				spp.anchor = Array(va,vb);\n"+
"			}\n"+
"			//Randomizes handles too\n"+
"			 if(uchoice!=1){\n"+
"				la = spp.leftDirection[0]+((Math.random()*rvar)-(rvar/2));\n"+
"				lb = spp.leftDirection[1]+((Math.random()*rvar)-(rvar/2))\n"+
"				spp.leftDirection = Array(la,lb);\n"+
"				 \n"+
"				ra = spp.rightDirection[0]+((Math.random()*rvar)-(rvar/2));\n"+
"				rb = spp.rightDirection[1]+((Math.random()*rvar)-(rvar/2))\n"+
"				spp.rightDirection = Array(ra,rb);\n"+
"			 }\n"+
"			}\n"+
"			\n"+

"		}\n"+
"		catch(e) {\n"+
"			alert('Problem Found:'+e);\n"+
"		}\n"+
"}\n"+
"function testObj(curr){\n"+
"		if(curr.typename =='PathItem' ){\n"+
"			tweakPath(curr);\n"+
"		} else if(curr.typename =='GroupItem'){\n"+
"			//can't tweak grouped items yet.\n"+
"			//activeDocument.selection[0]==activeDocument.groupItems[0]\n"+
"			//activeDocument.groupItems[0].pathItems\n"+
"			//activeDocument.selection[0].groupItems[0].pathItems[0]\n"+
"			//\n"+
"			//hit all path items in group...\n"+
"			var gpMax = curr.pathItems.length;\n"+
"			for(var gpi=0;gpi<gpMax;gpi++){\n"+
"				tweakPath(curr.pathItems[gpi]);\n"+
"			}\n"+
"			//hit all group items in group...\n"+
"			var grMax = curr.groupItems.length\n"+
"			for(var gri=0;gri<grMax;gri++){\n"+
"				testObj(curr.groupItems[gri]);\n"+
"			}\n"+
"		}\n"+
"		else{\n"+
"			//aint nothing to select.\n"+
"		}\n"+
		"}\n";
		bt.onError = flashPanelBridgeTalkErrorHandler;
		bt.send();	
	} 
	catch(e) {
		alert ("Exception caught in registerText():" + e);
	}	 

}

function sharpen(thingies,num ) {
	try{
		var bt2 = new BridgeTalk();
		bt2.target = "illustrator";	
		//send code:
		bt2.body = "{\n"+
"var doc = activeDocument;\n"+
"var sel = doc.selection;\n"+
"var sellen = sel.length;\n"+
"var ignoredItemCount = 0;\n"+
"var adjacentHandlesToo=0;\n"+
"var pct='"+num+"';\n"+
"//var pct='20';\n"+
"//---------------------------------------main code:\n"+
"//\n"+
"if(pct==0){\n"+
"	var myFunc = hoseHandles;\n"+
" }else{\n"+
"	var myFunc = knotHandles;\n"+
" }\n"+
"\n"+
"for(var x=0;x<sellen;x++){\n"+
"	if(sel[x].typename == 'PathItem'){\n"+
"		// knot control points of selected path items\n"+
"		myFunc(sel[x]);\n"+
"	}else if(sel[x].typename == 'CompoundPathItem'){\n"+
"		//knot control points of selected compound path items\n"+
"		var cpiLen = sel[x].pathItems.length;\n"+
"		for (var j=0;j<cpiLen;j++){\n"+
"			myFunc(sel[x].pathItems[j]);\n"+
"		}\n"+
"	\n"+
"	}else{\n"+
"			ignoredItemCount++;\n"+
"		}\n"+
"}\n"+
"if(ignoredItemCount>0){\n"+
"	alert('Just so you know:'+ignoredItemCount+' Item(s) ignored. Try selecting objects individually or ungrouping.');\n"+
"}\n"+
"//------------------------------functions below:\n"+
"function hoseThisAnchor(ptOb,deets){\n"+
"	var anch = ptOb.anchor;\n"+
"	var cntr_arr = Array(anch[0],anch[1]);\n"+
"	if(deets=='l'){\n"+
"		ptOb.leftDirection = cntr_arr;\n"+
"	} else if(deets=='r'){\n"+
"		ptOb.rightDirection = cntr_arr;\n"+
"	} else {\n"+
"		ptOb.leftDirection = cntr_arr;\n"+
"		ptOb.rightDirection = cntr_arr;\n"+
"	}		\n"+
"}\n"+
"function hoseHandles(ob){\n"+
"			var ppl = ob.pathPoints.length;\n"+
"			for(var y=0;y<ppl;y++){\n"+
"				if(isHosed(ob.pathPoints[y])){\n"+
"					adjacentHandlesToo=1;\n"+
"				}\n"+
"			}\n"+
"			for(var y=0;y<ppl;y++){\n"+
"					if(ob.pathPoints[y].selected==PathPointSelection.ANCHORPOINT){\n"+
"						hoseThisAnchor(ob.pathPoints[y]);\n"+
"					}\n"+
"				 if(adjacentHandlesToo==1){\n"+
"					if(ob.pathPoints[y].selected==PathPointSelection.LEFTDIRECTION){\n"+
"						hoseThisAnchor(ob.pathPoints[y],'l');\n"+
"					}\n"+
"					if(ob.pathPoints[y].selected==PathPointSelection.RIGHTDIRECTION){\n"+
"						hoseThisAnchor(ob.pathPoints[y],'r');\n"+
"					}\n"+
"				}\n"+
"			}	 \n"+
"}\n"+
"function isHosed(ptOb){\n"+
"	if(ptOb.leftDirection[0]==ptOb.rightDirection[0] && ptOb.anchor[0]==ptOb.rightDirection[0] && ptOb.leftDirection[1]==ptOb.rightDirection[1] && ptOb.anchor[1]==ptOb.rightDirection[1] && ptOb.selected==PathPointSelection.ANCHORPOINT){\n"+
"		return true;\n"+
"	}\n"+
"	return false;\n"+
"}\n"+
"function knotThisAnchor(ptOb,prevOb,nextOb){\n"+
"	var anch = ptOb.anchor;\n"+
"	var anchp = prevOb.anchor;\n"+
"	var anchn = nextOb.anchor;\n"+
"	var cntr_arr = Array(anch[0],anch[1]);\n"+
"	var next_arr = Array(anchp[0],anchp[1]); \n"+
"	var prev_arr = Array(anchn[0],anchn[1]); \n"+
"	var nextpos = calculatePos(cntr_arr,next_arr,pct)\n"+
"	var prevpos = calculatePos(cntr_arr,prev_arr,pct)\n"+
"	ptOb.leftDirection = prevpos;\n"+
"	ptOb.rightDirection = nextpos;\n"+
"}\n"+
"function knotHandles(ob){\n"+
"			var ppl = ob.pathPoints.length;\n"+
"			for(var y=0;y<ppl;y++){\n"+
"				if(ob.pathPoints[y].selected==PathPointSelection.ANCHORPOINT){\n"+
"					if(y==0){\n"+
"						knotThisAnchor(ob.pathPoints[y],ob.pathPoints[ppl-1],ob.pathPoints[y+1]);\n"+
"					} else if (y==ppl-1){\n"+
"						knotThisAnchor(ob.pathPoints[y],ob.pathPoints[y-1],ob.pathPoints[0]);\n"+
"					} else{ \n"+
"						 \n"+
"						knotThisAnchor(ob.pathPoints[y],ob.pathPoints[(y-1)],ob.pathPoints[(y+1)]);\n"+
"					}\n"+
"				}\n"+
"			}	 \n"+
"}\n"+
"function calculatePos(pt1,pt2,pct){\n"+
"var xsq = Math.pow(Math.max(pt1[0],pt2[0]) - Math.min(pt1[0],pt2[0]),2);\n"+
"var ysq = Math.pow(Math.max(pt1[1],pt2[1]) - Math.min(pt1[1],pt2[1]),2);\n"+
"var z = Math.sqrt(xsq+ysq);\n"+
"//\n"+
"var dx = (Math.max(pt1[0],pt2[0]) - Math.min(pt1[0],pt2[0]));\n"+
"var dy = (Math.max(pt1[1],pt2[1]) - Math.min(pt1[1],pt2[1]));\n"+
"if(pt1[0] < pt2[0]){\n"+
"	var nux = pt1[0]+(dx*(pct/100));\n"+
"} else {\n"+
"	var nux = pt1[0]-(dx*(pct/100));\n"+
"}\n"+
"if(pt1[1]<pt2[1]){\n"+
"	var nuy = pt1[1]+(dy*(pct/100));\n"+
"}else{\n"+
"	var nuy = pt1[1]-(dy*(pct/100));}\n"+
"return([nux,nuy]);\n"+
"}\n"+
		"}\n";
		bt2.onError = flashPanelBridgeTalkErrorHandler;
		bt2.send();	
	} 
	catch(e) {
		alert ("Exception caught in registerText():" + e);
	}	 

}
function vary(num) {
	try{
		 
		var bt2 = new BridgeTalk();
		bt2.target = "illustrator";	
		//send code:
		bt2.body = "{\n"+
"/////////////////////////////////////////////////////////////////\n"+
"//Vary Hues / Randomize Colors -- CS, CS2\n"+
"//>=--------------------------------------\n"+
"//     This script is designed to create color variations such as seen in brick walls, or stone walkways.\n"+
"//   \n"+
"//     When one or more objects are selected,\n"+
"//     the script provides a prompt to the user with the following three options:\n"+
"//    \n"+
"//     To vary the object(s) fill colors, enter a number from 0 to 100. 100 is maximum.\n"+
"//     To vary the object(s) strokes, add an 's' after the number like this: 42s\n"+
"//    \n"+
"//     The last option is slightly different, instead of entering a number for the variance,\n"+
"//     the user enters an opacity range.\n"+
"//     To vary the object(s) transparencies enter two comma separated numbers\n"+
"//     representing the minimum and maximum like this: 23,44\n"+
"//    \n"+
"//     Since the color values of spot colors by definition cannot be adjusted, the tint is randomized instead.\n"+
"//     Gradients and Patterns are not affected.\n"+
"//     Grouped, masked, or symbol objects are generally ignored. \n"+
"//>=--------------------------------------\n"+
"// JS code (c) copyright: John Wundes ( john@wundes.com ) www.wundes.com\n"+
"//copyright full text here:  http://www.wundes.com/js4ai/copyright.txt\n"+
"////////////////////////////////////////////////////////////////// \n"+
"//Randomize Colors.\n"+
"len = app.activeDocument.selection.length;\n"+
"gradAlert = 0;\n"+
"strokes = false;\n"+
"weight = false;\n"+
"var retChar = eval('String.fromCharCode(13)');\n"+
"if (len == 0) {\n"+
"	alert('Please select one or more objects. Grouped objects will not be affected.');\n"+
"} else {\n"+
"	ob = app.activeDocument.selection;\n"+
"	var line1 = '1) To vary FILL COLORS, enter a number: (1-100)'+retChar;\n"+
"	var line2 = '2) To vary STROKE COLORS, enter a number followed by an s'+retChar;\n"+
"	var line3 = '3) To vary OPACITIES, enter min and max values such as: 30,100'+retChar;\n"+
"	var line4 = '4) To vary STROKE WEIGHT, enter a number followed by a w';\n"+
"	var swfData = '"+num+"';\n"+
"if(swfData.substr(2,3)=='num'){\n"+
"	var data=prompt(line1+line2+line3+line4,20);\n"+
"} else {\n"+
"	var data = swfData;\n"+
"};\n"+
"	if ( data == null || data.length ==0 )\n"+
"	{\n"+
"	//User canceled process or didn't enter anything, so do nothing and end nicely.\n"+
"	} else{	 \n"+
"		if (data.indexOf(',')>0) {\n"+
"			action = data.split(',');\n"+
"		} else {\n"+
"			action = data.split(' ');\n"+
"		}\n"+
"		//if the 's' is it's own value in the array, detect and snip\n"+
"		var lastItem = action[action.length-1];\n"+
"		if (lastItem == 's') {\n"+
"			action.length = action.length-1;\n"+
"			strokes = true;\n"+
"		}\n"+
"		if (lastItem == 'w') {\n"+
"			action.length = action.length-1;\n"+
"			weight = true;\n"+
"		}\n"+
"		// or, detect and snip the 's' from the last number in the array \n"+
"		var lastChar = lastItem.charAt(lastItem.length-1);\n"+
"		if (lastChar == 's') {\n"+
"			action[action.length-1] = lastItem.substr(0,lastItem.length-1)\n"+
"			//alert(action);\n"+
"			strokes = true;\n"+
"		}\n"+
"		if (lastChar == 'w') {\n"+
"			action[action.length-1] = lastItem.substr(0,lastItem.length-1)\n"+
"			//alert(action);\n"+
"			weight = true;\n"+
"		}\n"+
"		if (action[action.length-1].charAt(action[action.length-1].length-1) == 'w') {\n"+
"			action[action.length-1] = action[action.length-1].substr(0,action[action.length-1].length-1)\n"+
"			//alert(action);\n"+
"			strokes = true;\n"+
"		} \n"+
"		var baseVal = action[0];\n"+
"		for (j=0; j<len; j++) {\n"+
"			//\n"+
"			if(lastChar == 'v'){\n"+
"				var op,r;\n"+
"					r = Math.round(Math.random(2));\n"+
"					if (r==1)\n"+
"					{\n"+
"						op = true;\n"+
"					}else {\n"+
"						op=false;\n"+
"					}\n"+
"					ob[j].hidden = op;\n"+
"				 \n"+
"			} else if (isNumber(action[0]) && isNumber(action[1]) && action.length == 2) {\n"+
"				//change OPACITY here\n"+
"				calcNum = ((action[0]*1)+((Math.random(1)*(action[1]-action[0]))));\n"+
"				ob[j].opacity = setLegal(calcNum);\n"+
"				//\n"+
"				//Change COLOR here:\n"+
"			} else if (isNumber(action[0], 255) && action.length == 1) {\n"+
"				//alert('Changing Color'+action[0]);\n"+
"				if(app.activeDocument.documentColorSpace == 'DocumentColorSpace.RGB'){\n"+
"					action[0] = Math.round(baseVal*2.55);\n"+
"				}\n"+
"				pathComOrGroup(ob[j],action[0]);\n"+
"				//\n"+
"			} else {\n"+
"				//break\n"+
"				j = len;\n"+
"				error(action[0]);\n"+
"			}\n"+
"		}\n"+
"	}\n"+
"}\n"+
"function pathComOrGroup(obj,num){\n"+
"		// process PathItems\n"+
"		try{\n"+
"			assignColor(obj,num);\n"+
"		}\n"+
"		catch(e){\n"+
"		// no PathItems here... shhh!\n"+
"		}\n"+
"		try{\n"+
"			var gcnt= obj.pathItems.length;\n"+
"			for(var gcx=0;gcx<gcnt;gcx++){\n"+
"				assignColor(obj.pathItems[gcx],num);\n"+
"			}\n"+
"		}\n"+
"		catch(e){\n"+
"		// no PathItems here either... shhh!\n"+
"		}\n"+
"		//process compoundPathItems\n"+
"		try{\n"+
"			var gcnt= obj.compoundPathItems.length;\n"+
"			for(var gcx=0;gcx<gcnt;gcx++){\n"+
"				pathComOrGroup(obj.compoundPathItems[gcx],num);\n"+
"			}\n"+
"		}\n"+
"		catch(e){\n"+
"		// no compound Paths here... shhh!\n"+
"		}\n"+
"		//process groupItems\n"+
"		try{\n"+
"			var gcnt= obj.groupItems.length;\n"+
"			for(var gcx=0;gcx<gcnt;gcx++){\n"+
"				pathComOrGroup(obj.groupItems[gcx],num);\n"+
"			}\n"+
"		}\n"+
"		catch(e){\n"+
"		// no groupItems here...  shhhh!\n"+
"		}\n"+
"}\n"+
"function assignColor(obj,num){\n"+
" if (weight == true){\n"+
"		if (obj.stroked == true) {\n"+
"			var rndPct= ((num*2)*Math.random(1))-num;\n"+
"			//var newStroke = Math.abs((ob[j].strokeWidth + rndPct/2)-(rndPct));\n"+
"			var rn1 = Math.random(1);\n"+
"			var rvar = (obj.strokeWidth*num*rn1)/100;\n"+
"			//assign\n"+
"			if(Math.round(Math.random(1))==1){\n"+
"				obj.strokeWidth = obj.strokeWidth+ rvar;\n"+
"			}else if (obj.strokeWidth - rvar >0){\n"+
"				obj.strokeWidth = obj.strokeWidth - rvar\n"+
"			}\n"+
"		}\n"+
"	} else if (strokes == false) {	\n"+
"		if (obj.filled == true) {\n"+
"			//alert(setLegal(num));\n"+
"			setColor(obj.fillColor, setLegal(num, 255));\n"+
"		}\n"+
"	} else {\n"+
"		if (obj.stroked == true) {\n"+
"			setColor(obj.strokeColor, setLegal(num,255));\n"+
"		}\n"+
"	}\n"+
"}\n"+
"function error(val) {\n"+
"	alert(val+' was not an accepted value.');\n"+
"}\n"+
"function isNumber(num, max) {\n"+
"	if (max == undefined) {\n"+
"		max = 100;\n"+
"	}\n"+
"	if (num>=0 && num<=max) {\n"+
"		return true;\n"+
"	}\n"+
"	return false;\n"+
"}\n"+
"function setLegal(num, max) {\n"+
"	if (max == undefined) {\n"+
"		max = 100;\n"+
"	}\n"+
"	if (num<0) {\n"+
"		return -num%max;\n"+
"	} else if (num>max) {\n"+
"		return max-(num%max);\n"+
"	} else {\n"+
"		return num;\n"+
"	}\n"+
"}\n"+
"function setColor(obj, dev) {\n"+
"	var d = Math.round(Math.random(1)*dev);\n"+
"	if (obj == undefined) {\n"+
"		//do nothing\n"+
"	} else if (obj.typename == 'RGBColor') {\n"+
"		//alert('RGB');\n"+
"		d = Math.round(Math.random(1)*dev);\n"+
"		var r = obj.red;\n"+
"		obj.red = setLegal((r-dev)+(d*2), 255);\n"+
"		d = Math.round(Math.random(1)*dev);\n"+
"		var g = obj.green;\n"+
"		obj.green = setLegal((g-dev)+(d*2), 255);\n"+
"		d = Math.round(Math.random(1)*dev);\n"+
"		var b = obj.blue;\n"+
"		obj.blue = setLegal((b-dev)+(d*2), 255);\n"+
"	} else if (obj.typename == 'SpotColor') {\n"+
"		//alert('Spot');\n"+
"		var d = Math.round(Math.random(1)*dev);\n"+
"		var t = obj.tint;\n"+
"		obj.tint = setLegal((t-dev)+(d*2), 100);\n"+
"	} else if (obj.typename == 'GrayColor') {\n"+
"		//alert('Gray');\n"+
"		var d = Math.round(Math.random(1)*dev);\n"+
"		var t = obj.gray;\n"+
"		obj.gray = (setLegal((t-dev)+(d*2), 100));\n"+
"	} else if (obj.typename == 'CMYKColor') {\n"+
"		//alert('CMYK');\n"+
"		d = Math.round(Math.random(1)*dev);\n"+
"		var c = obj.cyan;\n"+
"		obj.cyan = setLegal((c-dev)+(d*2), 100);\n"+
"		d = Math.round(Math.random(1)*dev);\n"+
"		var m = obj.magenta;\n"+
"		obj.magenta = setLegal((m-dev)+(d*2), 100);\n"+
"		d = Math.round(Math.random(1)*dev);\n"+
"		var y = obj.yellow;\n"+
"		obj.yellow = setLegal((y-dev)+(d*2), 100);\n"+
"		d = Math.round(Math.random(1)*dev);\n"+
"		var k = obj.black;\n"+
"		obj.black = setLegal((k-dev)+(d*2), 100);\n"+
"	} else if (gradAlert != 1 && (obj.typename == 'PatternColor' || obj.typename == 'GradientColor')) {\n"+
"		gradAlert = 1;\n"+
"		alert('Patterns and Gradients will not be transformed.');\n"+
"	} else {\n"+
"		//alert('Nuthin...');\n"+
"	}\n"+
"};\n"+
		"}\n";
		bt2.onError = flashPanelBridgeTalkErrorHandler;
		bt2.send();	
	} 
	catch(e) {
		alert ("Exception caught in registerText():" + e);
	}	 

}
function zoom() {
	/////////////////////////////////////////////////////////////////
	//Randomizes all selected anchors by a selected number of points.
	//
	//  Enter small numbers to make objects look hand drawn.
	//  Enter larger numbers to make objects look organic.
	//  Enter even larger numbers to distort beyond recognition.
	//
	// V.2 now offers a choice for randomizing 'Anchors Only', 'Control Handles Only' or both.
	//  <a href='http://www.wundes.com/js4ai/images/organifyDetail.gif'>(click here to view sample image.)</a>
	//>=--------------------------------------
	// JS code (c) copyright: John Wundes ( john@wundes.com ) www.wundes.com
	//copyright full text here:  http://www.wundes.com/js4ai/copyright.txt
	////////////////////////////////////////////////////////////////// 
	try{
		var bt = new BridgeTalk();
		bt.target = "illustrator";
		//"alert('"+thingies+"'+'"+num+":');"+	
		//send code:
		bt.body = "{\n"+
		"if ( documents.length > 0)\n"+
		"{\n"+
		"	if(activeDocument.selection.length >0){\n"+
		"		mySelection = activeDocument.selection;\n"+
		"		//if object is a (collection of) object(s) not a text field.\n"+
		"		if (mySelection instanceof Array) {\n"+
		"			//initialize vars\n"+
		"			initBounds = mySelection[0].visibleBounds;\n"+
		"			ul_x = initBounds[0];\n"+
		"			ul_y = initBounds[1];\n"+
		"			lr_x = initBounds[2];\n"+
		"			lr_y = initBounds[3];\n"+
		"			//check rest of group if any\n"+
		"			for (i=1; i<mySelection.length; i++) {\n"+
		"			groupBounds = mySelection[i].visibleBounds;\n"+
		"			if (groupBounds[0]<ul_x){ul_x=groupBounds[0]}\n"+
		"			if (groupBounds[1]>ul_y){ul_y=groupBounds[1]}\n"+
		"			if (groupBounds[2]>lr_x){lr_x=groupBounds[2]}\n"+
		"			if (groupBounds[3]<lr_y){lr_y=groupBounds[3]}\n"+
		"			}\n"+
		"		}\n"+
		"		activeDocument.views[0].zoom = 1;\n"+
		"		ScreenSize = activeDocument.views[0].bounds;\n"+
		"		ScreenWidth= ScreenSize[2] - ScreenSize[0];\n"+
		"		ScreenHeight=ScreenSize[1] - ScreenSize[3];\n"+
		"		screenProportion =ScreenHeight/ScreenWidth;\n"+
		"		cntrPos = [ul_x,ul_y];\n"+
		"		mySelWidth=(lr_x-ul_x);\n"+
		"		mySelHeight=(ul_y-lr_y);\n"+
		"		cntrPos[0] = ul_x + (mySelWidth/2);\n"+
		"		cntrPos[1] = ul_y - (mySelHeight/2);\n"+
		"		activeDocument.views[0].centerPoint =  cntrPos;\n"+
		"		zoomFactorW = ScreenWidth/mySelWidth;\n"+
		"		zoomFactorH = ScreenHeight/mySelHeight;\n"+
		"		//decide which proportion is larger...\n"+
		"	if((mySelWidth*screenProportion) >= mySelHeight){\n"+
		"		zF = zoomFactorW;\n"+
		"	}else{\n"+
		"		zF = zoomFactorH;\n"+
		"	}\n"+
		"	activeDocument.views[0].zoom = zF *.85;\n"+
		"	}else{\n"+
		"		activeDocument.activeView.zoom=1;\n"+
		"	}\n"+
		"}\n"+
		"}\n";
		bt.onError = flashPanelBridgeTalkErrorHandler;
		bt.send();	
	} 
	catch(e) {
		alert ("Exception caught in registerText():" + e);
	}	 

}